Package net.sf.saxon.expr.instruct

## Class FixedAttribute

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.SimpleNodeConstructor
      - - net.sf.saxon.expr.instruct.AttributeCreator
        - - net.sf.saxon.expr.instruct.FixedAttribute

- All Implemented Interfaces:
    `ExportAgent`, `TailCallReturner`, `ValidatingInstruction`, `Locatable`, `IdentityComparable`, `Traceable`

      public final class FixedAttribute
      extends AttributeCreator

  An instruction derived from an xsl:attribute element in stylesheet, or from an attribute constructor in XQuery. This version deals only with attributes whose name is known at compile time. It is also used for attributes of literal result elements. The value of the attribute is in general computed at run-time.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `selectOp`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FixedAttribute​(NodeName nodeName, int validationAction, SimpleType schemaType)` | Construct an Attribute instruction

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkPermittedContents​(SchemaType parentType, boolean whole)` | Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `NodeInfo` | `evaluateItem​(XPathContext context)` | Evaluate as an expression.
    `NodeName` | `evaluateNodeName​(XPathContext context)` | Run-time method to compute the name of the node being constructed.
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `void` | `gatherProperties​(java.util.function.BiConsumer<java.lang.String,​java.lang.Object> consumer)` | Get the properties of this object to be included in trace messages, by supplying the property values to a supplied consumer function
    `int` | `getAttributeFingerprint()` | Get the name pool name code of the attribute to be constructed
    `NodeName` | `getAttributeName()` |
    `int` | `getCardinality()` | Determine the static cardinality of the expression.
    `java.lang.String` | `getExpressionName()` | Get a name identifying the kind of expression, in terms meaningful to a user.
    `int` | `getInstructionNameCode()` | Get the name of this instruction (return 'xsl:attribute')
    `void` | `localTypeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Method to perform type-checking specific to the kind of instruction
    `java.lang.String` | `toShortString()` | Produce a short string identifying the expression for use in error messages

    - ### Methods inherited from class net.sf.saxon.expr.instruct.AttributeCreator

      `computeSpecialProperties, getItemType, getOptions, getSchemaType, getValidationAction, isInstruction, processValue, setInstruction, setNoSpecialChars, setOptions, setRejectDuplicates, setSchemaType, setValidationAction, validateOrphanAttribute`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `allowExtractingCommonSubexpressions, alwaysCreatesNewNodes, checkContent, computeCardinality, getSelect, getStreamerName, isLocal, iterate, mayCreateNewNodes, operands, optimize, processLeavingTail, setSelect, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getImplementationMethod, getNetCost, getSourceLocator, isXSLT, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkedOperands, checkForUpdatingSubexpressions, computeDependencies, computeHashCode, computeStaticProperties, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, toString, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FixedAttribute

          public FixedAttribute​(NodeName nodeName,
                                int validationAction,
                                SimpleType schemaType)

      Construct an Attribute instruction
      Parameters:
        `nodeName` - Represents the attribute name
        `validationAction` - the validation required, for example strict or lax
        `schemaType` - the schema type against which validation is required, null if not applicable of the instruction - zero if the attribute was not present

  - ### Method Detail

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction (return 'xsl:attribute')
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### getExpressionName

          public java.lang.String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `Instruction`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

    - #### getAttributeName

          public NodeName getAttributeName()

    - #### gatherProperties

          public void gatherProperties​(java.util.function.BiConsumer<java.lang.String,​java.lang.Object> consumer)

      Get the properties of this object to be included in trace messages, by supplying the property values to a supplied consumer function
      Parameters:
        `consumer` - the function to which the properties should be supplied, as (property name, value) pairs.

    - #### localTypeCheck

          public void localTypeCheck​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Method to perform type-checking specific to the kind of instruction
      Specified by:
        `localTypeCheck` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of the context item
      Throws:
        `XPathException` - if a type error is detected

    - #### getAttributeFingerprint

          public int getAttributeFingerprint()

      Get the name pool name code of the attribute to be constructed
      Returns:
        the attribute's name code

    - #### getCardinality

          public int getCardinality()

      Description copied from class: `Expression`
      Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.
      Overrides:
        `getCardinality` in class `Expression`
      Returns:
        one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - a mutable list of (old binding, new binding) pairs that is used to update the bindings held in any local variable references that are copied.
      Returns:
        the copy of the original expression

    - #### evaluateNodeName

          public NodeName evaluateNodeName​(XPathContext context)

      Description copied from class: `SimpleNodeConstructor`
      Run-time method to compute the name of the node being constructed. This is overridden for nodes that have a name. The default implementation returns null, which is suitable for unnamed nodes such as comments
      Overrides:
        `evaluateNodeName` in class `SimpleNodeConstructor`
      Parameters:
        `context` - the XPath dynamic evaluation context
      Returns:
        the name pool nameCode identifying the name of the constructed node

    - #### checkPermittedContents

          public void checkPermittedContents​(SchemaType parentType,
                                             boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### evaluateItem

          public NodeInfo evaluateItem​(XPathContext context)
                                throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Evaluate as an expression.
      Overrides:
        `evaluateItem` in class `SimpleNodeConstructor`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### toShortString

          public java.lang.String toShortString()

      Produce a short string identifying the expression for use in error messages
      Overrides:
        `toShortString` in class `Expression`
      Returns:
        a short string, sufficient to identify the expression